#ifndef __IjQLAttrDefn_hpp
#define __IjQLAttrDefn_hpp
// \file IjQLAttrDefn.hpp
// \par Description
// Interface class for the IjQLAttrDefn class, for use by jEDI drivers.
//
// *ALL* access to jQL objects directly, related to the jQLAttrDefn objects *MUST* occur
// within the context of these Interface classes.
//
// These classese *MUST ONLY* be changed on the authority of the jEDI Driver Team.
//
#ifdef _WIN32
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#endif

// Implementation in Phase II

/// Forward Declarations (for constructors, temp & private access methods)
class jQLAttrDefn;	// for IjQLAttrDefn constructor
class jQLAttrIndex;	// for IjQLAttrIndex constructor
class ConvControlBlock;	// return type from TEMP_ method; Should eventually be removed? 
class CVar;	// return type from many methods.

//typedef VECTOR_ATTRIBUTEINDEXES; // return type from TEMP_ method; Should eventually be removed? 
typedef std::vector<jQLAttrIndex*> VECTOR_ATTRIBUTEINDEXES; // Can't 'forward declare' typedefs, as above :(

// These directly equate to the non-IJQL variants, declared (const int) in ConvControlBlock.h
enum IJQL_JUST {
	IJQL_LEFTJUST = 0,
	IJQL_RIGHTJUST = 1,
	IJQL_TEXTJUST = 2,
	IJLQ_CENTERJUST = 3,
	IJQL_ULEFTJUST = 4
};

/////////////////////////////////////////////////////////////////////////////
class JBUILD_EXPORT IjQLAttrDefn  
{
protected:
public:
	//
	// Constructors
	//
	IjQLAttrDefn(jQLAttrDefn *vattrdef = 0);
	//
	// Destructor
	//
	//virtual ~IjQLAttrDefn();

	//
	// Property Accessors
	//
	//CVar    *getAttrKey();
	//bool	getReversible();

	//int		getAttrNo();
	const int		getAttrNo() const;	// {return _pAttrDefn->getAttrNo();};
	//int		getOverrideAttrNo();
	//int		getUpdatedAttrNo();

	//CVar&	getItypeVar();
	CVar&	getItypeVar() const; // { return _pAttrDefn->getItypeVar(); }
	//Else: const CVar&	getItypeVar() const; // { return _pAttrDefn->getItypeVar(); }
	//int		getColumnNumber();
	//int		getStorageFormat();
	//int		getDataType();
	//int		getDisplayWidth();
	const int getDisplayWidth() const;	// { return _pAttrDefn->getDisplayWidth();} ;
	//int		getJust();
	const int getJust() const;	// { return someconversion(_pAttrDefn->getJust());}
	//char	getType();
	//char	getValueType();
	const char	getValueType() const;
	//CVar&	getHeading();
	//CVar&	getColumnName();
	/*const*/ CVar&	getColumnName() const;	// {return _pAttrDefn->getColumnName(); };
	//CVar&	getAttr7();
	//CVar&	getAttr8();
	//CVar&	getFKTable();
	//CVar&	getFKColumns();
	//CVar&	getFormat();
	//CVar&	getMVGroupName();
	//CVar&	getSVGroupName();
	//CVar&	getDictIID();
	/*const*/ CVar&	getDictIID() const; // {return dictIIDVar;}
	//bool	getDeleteCID();
	//int		getSource();
	//int		getScale();
	//int		getPrecision();
	//jQLStatement *getStatement();

	//bool	isIndexable();
	//ConvControlBlock* getAttr7CCB();
	//ConvControlBlock* getAttr8CCB();
	ConvControlBlock* TEMP_getAttr8CCB() const;	// {return _pAttrDefn->getAttr8CCB(); };
	// Else: /*const*/ ConvControlBlock* TEMP_getAttr8CCB() const;	// {return _pAttrDefn->getAttr8CCB(); };
	// Else: /*const*/ IjQLConvControlBlock* getAttr8CCB() const //	{return _pAttr8CCB; };
	bool has_Attr8CCB() const;	// {return _pAttrDefn->getAttr8CCB(); };

	//DllExport ConvItemDescriptor* getCID();
	//jQLAssocMgr* getAssociations();
	
	// Get extended attrib's
	//int getFlags();

	//
	// New helper methods to remove ConvConvtrolBlock and AST accesses from driver...
	//
	int get_Width_from_Attr8CCB_FormatPtr() const;
	bool is_Attr8CCB_ConvType_a_Tran() const;
	bool get_Tran_params_from_Attr8CCB(int *ptAttrNo, VAR **ptfilevar, int *plength) const;
	bool is_Attr8CCB_ConvType_a_Itype() const;
	bool get_Itype_LOCALREF_params_from_Attr8CCB(DPSTRUCT * dp, int *pam, int *pmv, int *psv) const;

	//
	// Property Modifiers
	//
	//void setHeading(CVar& newHeading);
	//void setDisplayWidth(int newWidth);
	//void setColumnNumber( int p );
	//void setAssociatonPtr(jQLAssociation *ptr);
	//void setOverrideAttrNo( int p );
	//void setCID(ConvItemDescriptor* _CID);
	//void setDeleteCID(bool p);
	//void setJust(int j);
	//void setSource(int p);
	//void setDataType(int _datatype);

	//void ParseAttr();
	//void defaultExtDict();
	//bool isDefaultPlaceHolder();
	//CVar&	getValue(int valueNo =0, int subValueNo = 0);
	//CVar&	getValue(int attrNumber,int valueNo, int subValueNo);

	//CVar& getNextResult(bool* moreVals, int* valueNo);
	//CVar& getNextITypeResult(bool* moreVals, int* valueNo);
	//void resetITypeResultPointer();	

	// Used in sort processor for selects on multiple itypes so we can pass the result back in to avoiding needing a new datasource
	//void overideITypeResultPointer(unsigned char *_iTypePtr);

	//void resetToFirstValue();
	//const CVar& processIconv(const CVar& literalVar);
	//void addCandidateIndex(jQLIndexSubSegment* subSegPtr);
	//jQLIndexSubSegment* getFrontIndex();
	//void setAttrIndexTest(jQLAttrIndex *withTest);
	//jQLAttrIndex **getAttrIndexTests();
	//int	getNumSelTests();
	const int getNumSelTests() const;	// { return _pAttrDefn->getNumSelTests(); }
	//int getNumIndexPtrs();
	//jQLAssociation *getAssociationPtr();
	//bool addToAssociation(jQLOutputColumn* outColumn);
	//void setAttrKey(CVar &key);
	//void setupJSQLStuff();

	//VECTOR_INDEXCANDIDATES idxPtrs;
	///////////////////////////////////////////////////
	//VECTOR_ATTRIBUTEINDEXES	selTests;
	//Not sure how to wrap the direct accesses to this vector? Something like:
	/*const*/ VECTOR_ATTRIBUTEINDEXES&	TEMP_get_selTests() const; // { return _pAttrDefn->selTests; };
	//////////////////////////////////////////////////

private:
	jQLAttrDefn *_pAttrDefn;
};


class JBUILD_EXPORT IjQLAttrIndex  
{
private:
	jQLAttrIndex *_pAttrIndex;

public:
	IjQLAttrIndex(jQLAttrIndex *vattridx = 0);
	//jQLAttrIndex() { operatorType = -5; compareType = -5; }
	//jQLAttrIndex(jQLBaseSelTest* sel, int op, int compType, CVar& val);

	//int		getOperatorType();
	const int		getOperatorType() const;	// { return operatorType; }
	//int		getCompareType();
	const int		getCompareType() const;	// { return compareType; }
	//jQLBaseSelTest *getSelectTest();
	//CVar&	getValue();
	CVar&	getValue() const; // { return value; }
	//bool	haveSeen();
	//void	setSeenMe(bool s);
	//bool	getCoverageFlag():
	//void	setCoverageFlag( bool s );
};

#endif // __IjQLAttrDefn_hpp
