#ifndef __IjQLOutputSelectList_hpp
#define __IjQLOutputSelectList_hpp
// \file IjQLOutputSelectList.hpp
// \par Description
// Interface class for the jQLOutputSelectList class, for use by jEDI drivers.
//
// *ALL* access to jQL objects directly, related to the jQLOutputSelectList objects *MUST* occur
// within the context of this Interface class.
//
// This class *MUST ONLY* be changed on the authority of the jEDI Driver Team.
//

// Implementation in Phase II

// Forward Declarations
class jQLOutputSelectList;	// class being proxied
class CVar;					// Used for parameters

class JBUILD_EXPORT IjQLOutputSelectList : public IjQLOutputBase
{
public:
	IjQLOutputSelectList(jQLOutputSelectList *jQLOutputSelectList);	//: _pjQLOutputSelectList(&jQLOutputSelectList) { };
	virtual ~IjQLOutputSelectList();

	virtual void Output();
	virtual void Output(CVar &inKey);
	virtual void setAcceptedItemCount(int ItemCount);

protected:

	// private methods
private:
	// Prevent copying...
	IjQLOutputSelectList(IjQLOutputSelectList& rh);
	IjQLOutputSelectList& operator=(IjQLOutputSelectList& rh);

	// private members
private:
	jQLOutputSelectList *_pjQLOutputSelectList;
};

#endif // __IjQLOutputSelectList_hpp
