#ifndef __IjQLSortProcessor_hpp
#define __IjQLSortProcessor_hpp
// \file IjQLSortProcessor.hpp
// \par Description
// Interface class for the jQLSortProcessor class hierarchy, for use by jEDI drivers.
//
// *ALL* access to jQL objects directly, related to the jQLSortProcessor objects *MUST* occur
// within the context of this Interface class.
//
// This class *MUST ONLY* be changed on the authority of the jEDI Driver Team.
//

// Implementation in Phase II

// Forward Declarations
class jQLBaseSortClass;
class jQLSortProcessor;
class jQLSqlSortProcessor;
class jQLkeySegment;

class IjQLAttrDefn;

class JBUILD_EXPORT IjQLkeySegment
{
public:
	IjQLkeySegment();
	virtual ~IjQLkeySegment();
	void setupFromjQLkeySegment(jQLkeySegment* _keySeg);
	//void setup(ANTLR_USE_NAMESPACE(antlr)RefAST currentAST,ANTLR_USE_NAMESPACE(antlr)RefAST outputAST,bool& needexplode, bool& needsubexplode, bool desc, int col, int sortColNum);
	//void setup(antlr::RefAST currentAST,bool& needexplode, bool& needsubexplode);
	//void setupFromAttrDef(jQLAttrDefn* _attributeDefn,bool _resultField);
	//bool BuildKey(struct jBASEDataAreas *dp,int& fullKeyLength, bool isSql);
	//bool BuildKeyEx(struct jBASEDataAreas *dp,int& fullKeyLength, int attrNo, jQLItemAccess* itemSrc);
	//CVar* getKeyValue(){return &KeyVar;}
	//int getOutputColumnNumber() { return outputColumnNumber; }
	//void setExploding(bool t) { exploding = t; }
	//void setSubExploding(bool t) { subExploding = t; }
	//bool isRightJustified() { return rightjustified; }
	//bool isDescending() { return descending; }
	bool isDescending() const; //{ return descending; }
	//CVar* getAttrVal()  { return &AttrValue; };
	//jQLAttrDefn* getAttributeDefn() { return attributeDefn; }
	IjQLAttrDefn* getAttributeDefn() const;	// { return attributeDefn; }

 //	inline bool isRightjustified() { return rightjustified; }
 //	inline bool isResultField() { return resultField; }

private:
	jQLkeySegment *_pjQLkeySegment;
	//bool descending;	
	//bool exploding;
	//bool subExploding;
	//bool rightjustified;
	//bool resultField;
	//bool useCollationTable;
	//bool justificationSet;
	//int  outputColumnNumber;
	IjQLAttrDefn* attributeDefn;
	//jQLBaseSelTest* limiterTree;
	//CVar AttrValue;
	//CVar KeyVar;
	//CVar UnicodeVar;
};

//class IjQLKey
//{
//public:
//	IjQLKey();
//	~IjQLKey();
//	//IjQLKey* next;
//	//int IIDoffset;
//	//int valueNum;
//	//int subValueNum;
//	//CVar *originalData;
//	//char keyStart;
//};

class JBUILD_EXPORT IjQLSqlSortProcessor
{
public:
	IjQLSqlSortProcessor(jQLBaseSortClass* sortProcessor);
	~IjQLSqlSortProcessor();
//	bool GetNextItem();
//	int GetKeyCount() {return 0;}
//	void AddKey(VAR *item, VAR *itemId);

	// Inherited from jQLSortProcessor
	int GetsortSegmentCount() const;	// { return _pSortProcessor->GetsortSegmentCount(); } // Total number of segments to sort by
	jQLkeySegment* TEMP_GetkeyArray() const;	// { _pSortProcessor->GetkeyArray(); }
	IjQLkeySegment* GetkeyArray() const;	// { _pSortProcessor->GetkeyArray(); }

private:
	jQLSqlSortProcessor *_pSortProcessor;
	IjQLkeySegment* keyArray;
};

#endif // __IjQLSortProcessor_hpp
