/*
 * This is the header file for the REALITY jEDI.
 * # Copyright (c) 2019 jBASE International. All rights reserved
 */
#define	REALITY_SERVER_NAME	"jREALITY"		/* Name of the server program */
#define	REALITY_BUFF_SIZE	256				/* Size of the multi-usage buffer */
#define	REALITY_BLOCK_SIZE	512				/* If we have to block reads/writes, this is the size */
#define	REALITY_STAT_BUFF_SIZE	4096		/* Size of buffer for the 'jstat' command */
/*
 * Define the structure passed to the server program.
 */
struct	REALITYcmd
{
	int		cmd ;							/* One of the REALITY_CMD_xxx values */
	int		handle ;						/* The handle associated with the file */
	int		operand1 ;						/* Miscellaneous operand */
	int		operand2 ;						/* Miscellaneous operand */
	int		operand3 ;						/* Miscellaneous operand */
	long	operand4 ;						/* Miscellaneous operand */
	char	buff[REALITY_BUFF_SIZE] ;		/* General purpose buffer */
} ;
/*
 * Define the strucure used for SELECT purposes.
 */
struct	REALITYSelect
{
	long	RealityHandle ;					/* The handle returned by REALITY */
} ;
/*
 * Define the base structure passed back to the client.
 */
struct	REALITYrtn
{
	int		rcode ;							/* Return code, 0 shows all okay, any other is an error */
	int		operand1 ;						/* Miscellaneous operand */
	long	operand2 ;						/* Miscellaneous operand */
	char	buff[REALITY_BUFF_SIZE] ;		/* General purpose buffer */
} ;
/*
 * Define the commands that can be asked of the server.
 */
#define	REALITY_CMD_ACK			1			/* Simply acknowledge the server is active */
#define	REALITY_CMD_EXIT		2			/* Exit the server program */
#define	REALITY_CMD_OPEN		3			/* Open the file */
#define	REALITY_CMD_CLOSE		4			/* Close the file */
#define	REALITY_CMD_READ		5			/* Read a record */
#define	REALITY_CMD_WRITE		6			/* Write a record */
#define	REALITY_CMD_DELETE		7			/* Delete a record */
#define	REALITY_CMD_CLEAR		8			/* Clear a file, remove all records */
#define	REALITY_CMD_SELECT		9			/* Begin the selection of a file */
#define	REALITY_CMD_SELECT_END	10			/* End the selection of a file */
#define	REALITY_CMD_READNEXT	11			/* Read the next item id from the selection */
#define	REALITY_CMD_JSTAT		12			/* Return text data about the file */
#define	REALITY_CMD_LOCK		13			/* Lock and unlock locks */
#define	REALITY_CMD_CREATE_FILE	14			/* Create a new file or the stub to a file */
#define	REALITY_CMD_DELETE_FILE	15			/* Delete an existing file */
#define	REALITY_CMD_GET_FILENAME	16		/* Get the name of an existing opened file */
