#ifdef __cplusplus
extern "C" {
#endif

typedef struct jhndle_s {
	int Fd;
	int HdrSz;
	int MsgSz;
} jhndle_t ;

typedef jhndle_t *jhndle_p ;

typedef unsigned int jCON_UINT32;

typedef struct jmsghdr_s {
	jCON_UINT32 Magic;
	jCON_UINT32 Function;
	jCON_UINT32 Reference;
	jCON_UINT32 MaxDataLen;
	jCON_UINT32 DataLen;
	jCON_UINT32 StrLen;
	jCON_UINT32 User1;
	jCON_UINT32 User2;
	jCON_UINT32 User3;
	jCON_UINT32 User4;
} jmsghdr_t ;


#define jCONNECT_MAX_MSG_SIZE 16384 
#define jCONNECT_HDR_SIZE sizeof(jmsghdr_t)
#define jCONNECT_MAX_HDR_SIZE jCONNECT_HDR_SIZE + 1024
#define jCONNECT_MAX_STR_LEN ( jCONNECT_MAX_HDR_SIZE - jCONNECT_HDR_SIZE )

typedef struct jmsg_s {
	jmsghdr_t Hdr;
	unsigned char Str[jCONNECT_MAX_STR_LEN];
} jmsg_t ;

typedef jmsg_t *jmsg_p;


int jConnect(jhndle_p Handle, char *Host, char *Server, char *UserName);
int jSend(jhndle_p Handle, jmsg_p MsgPtr, char *MsgDataPtr);
int jDisconnect(jhndle_p Handle, int Errno);
JBASE_EXPORT int jRecWait(jhndle_p Handle, jmsg_p MsgPtr, char *MsgDataPtr, int Timer);
JBASE_EXPORT int jAccept(jhndle_p Handle, char *Host, char *Server, int AcceptFlags);
JBASE_EXPORT int jRecMore(jhndle_p Handle, char *MsgDataPtr, int Length);

#define INETD_STARTED 0x0001
#define RUN_FOREGROUND 0x0002
#define RUN_ITERATIVE	0x0004
#define RUN_BASICSERVER 0x0008
#define jDISCONNECT -1
#define jTIMEOUT -2
#define jITERATIVE_ERROR -3
#define jMOREDATA 1

#ifdef __cplusplus
}
#endif
