#!/bin/sh
set +x 
#
#	jDEMON: jBASE demons start/stop script
#
#	Copyright (c) 2019 jBASE International. All rights reserved
#
#	All Rights Reserved.
#
# To start the jBASE demons up automatically on powerup then perform
# the following:
# -	 Copy this script into "/etc/init.d/jDEMON"
# -  Make a link to the script from the directory /etc/rc2.d, with a name of
#	 the form S<xx>jDEMON.  The <xx> field should be replaced by two digits,
#	 for example 99, (signifies the order in which scripts are to be run).
#
#	 eg		ln /etc/init.d/jDEMON /etc/rc2.d/S99jDEMON
#
# JBCRELEASEDIR may not be set when this script is running.
#
if [ -z "$JBCRELEASEDIR" ]
then
	JBCRELEASEDIR=/opt/jbase5/5.2
fi

PATH=/bin:/usr/bin:$JBCRELEASEDIR/bin;
LD_LIBRARY_PATH=$JBCRELEASEDIR/lib; export LD_LIBRARY_PATH
SHLIB_PATH=$JBCRELEASEDIR/lib;export SHLIB_PATH
LIBPATH=$JBCRELEASEDIR/lib;export LIBPATH
USAGE="Usage: $0 {start | stop }"

RelFile=${JBCRELEASEDIR}/RELEASE
Rel=`cut -d: -f2 $RelFile | awk 'NR==1 {print $1}'`
echo "\njBASE version $Rel, Copyright (c) 2019 jBASE International. All rights reserved"

#
# Define the program name of the demons
#
ExecRLA=jDLS
#
# Define the options to the demons to start them.
#
StartOptionsRLA="-ib"
#
# Define the options to the demons to stop them.
#
StopOptionsRLA="-k"

case "$1" in
'start')
	echo "Starting $ExecRLA ..."
	$ExecRLA $StartOptionsRLA
	sleep 1

	;;

'stop')
	echo "Stopping $ExecRLA ..."
	$ExecRLA $StopOptionsRLA
	sleep 1

	;;
*)
	echo $USAGE
	exit 1
	;;
esac
echo
